<?php
namespace nur\sery\wip\schema\types;

use nulib\ValueException;
use nur\sery\wip\schema\_scalar\ScalarResult;
use nur\sery\wip\schema\_scalar\ScalarSchema;
use nur\sery\wip\schema\input\Input;
use nur\sery\wip\schema\Result;
use nur\sery\wip\schema\Schema;

class tgeneric extends _tsimple {
  function __construct(string $class, bool $nullable, ?array $params=null) {
    $this->class = $class;
    parent::__construct($nullable, $params);
  }

  protected string $class;

  function getClass(): string {
    return $this->class;
  }

  function isAvailable(Input $input, $valueKey): bool {
    return $input->isAvailable($valueKey);
  }

  public function isNull($value): bool {
    return $value === null;
  }

  function isValid($value, ?bool &$normalized=null): bool {
    $normalized = $value instanceof $this->class;
    return $normalized;
  }

  function parse(string $value) {
    throw ValueException::invalid_type($value, $this->class);
  }

  /**
   * @var ScalarResult $result
   * @var ScalarSchema $schema
   */
  function normalize(&$value, Result $result, Schema $schema): bool {
    if (!$result->normalized) $result->setNormalized();
    return false;
  }

  function format($value, $format=null): string {
    return strval($value);
  }
}
